<?php
defined( '_JEXEC' ) or die( 'Restricted access' );
jimport('joomla.plugin.helper');
class plgjshoppingcheckoutcheck_tax_for_EU extends JPlugin {
    
	function __construct(&$subject, $config){
		parent::__construct($subject, $config);	 
	}
	
	
    public function onBeforeSaveCheckoutStep2(&$adv_user){
	    
		$flag = 0;

        $country_id = $adv_user->country;
	    $vatid = strval($adv_user->tax_number);
        $vatid = str_replace(array(' ', '.', '-', ',', ', '), '', trim($vatid));
        $cc = substr($vatid, 0, 2);
        $vn = substr($vatid, 2);        
        
	    $db = JFactory::getDBO();
	    $query = "SELECT country_code_2 FROM #__jshopping_countries AS contr
	              WHERE contr.country_id=".$country_id;
	    $db->setQuery($query);
	    $country_code = $db->loadResult();
	    if ($country_code <> $cc) $this->redir(4);

        $client = new SoapClient("http://ec.europa.eu/taxation_customs/vies/checkVatService.wsdl");

        if($client){
            $params = array('countryCode' => $cc, 'vatNumber' => $vn);
            try{
                $r = $client->checkVat($params);

                if($r->valid == true){
                    $flag = 1;
                } else {
                    $flag = 0;
                }

            } catch(SoapFault $e) {
                $this->redir(5, 'Error, message: '.$e->faultstring);
            }
        } else {
            $this->redir(5, 'Connection to host not possible, europe.eu ');
        }        

		if ($flag == 0) $this->redir(3);
    }
	
	
    function redir ($error_type, $error='') {
	   $lang = JFactory::getLanguage();
       $lang->load('plg_jshoppingcheckout_check_tax_for_EU', JPATH_ADMINISTRATOR);
	   if ($error_type == 1) $err = JText::_('WRONG_SYMBOLS');
	   if ($error_type == 2) $err = JText::_('INCORRECT_VALUE');
	   if ($error_type == 3) $err = JText::_('WRONG_FORMAT');
	   if ($error_type == 4) $err = JText::_('WRONG_COUNTRY_CODE');
       if ($error_type == 5) $err = $error;
	   $jshopConfig = JSFactory::getConfig();
	   $uri = JURI::getInstance();
	   $liveurlhost =$uri->toString( array("scheme",'host', 'port'));
	   $product_link =SEFLink('index.php?option=com_jshopping&controller=checkout&task=step2',0,1, $jshopConfig->use_ssl);
	   $fullurl = $liveurlhost.$product_link;
	   $mainframe = JFactory::getApplication();
       $mainframe->redirect($fullurl, $err, 'error');
	}	
}
?>